﻿Type=StaticCode
Version=1.8
ModulesStructureVersion=1
B4R=true
@EndOfDesignText@


Sub Process_Globals
	Private bc As ByteConverter
	Private Astream As AsyncStreams	
	Private server As WiFiServerSocket
	Private eeprom As EEPROM
	Private Pos_Telefone As UInt = 1
	Private Pos_Redes As UInt = 21
	Private const MAGIC_EEPROM As Byte = 123
	Dim macarray(6) As Byte
End Sub

Public Sub Start
	Log("StartAP: ", Main.WiFi.StartAccessPoint("esp"))
	Log("My AP ip: ", Main.WiFi.AccessPointIp)
	server.Initialize(80, "server_NewConnection")
	server.Listen
End Sub

Private Sub Server_NewConnection (NewSocket As WiFiSocket)
	Astream.Initialize(NewSocket.Stream, "astream_NewData", "astream_Error")
End Sub


'192.168.4.1/set/mac   - get the MAC adress
'192.168.4.1/set/redes/ssid,password   / save the ssid and password
'192.168.4.1/set/telefones/xxxxxxxxx - save the celphone number
'192.168.4.1/set/eeprom  ' read the phone number and ssid and password
Private Sub Astream_NewData (Buffer() As Byte)
	Dim  cmd ="", par1 ="", par2="", par3 = "" As String
	Dim xResp() As Byte

'	Log(Buffer)
'	Log ( "--- buffer -------")
	If bc.IndexOf(Buffer, "GET") <> -1 Then
		If bc.IndexOf(Buffer, "/set") <> -1 Then
'Log ( "GET:" , Buffer )	
'Log ( "*********************")		
			Dim i1 As Int = 0
			Dim i2 As Int = 0
			For Each b1() As Byte In bc.Split(Buffer, " ")
				If i1 = 1 Then
					For Each b2() As Byte In bc.Split(b1, "/")
						Select i2
							Case 2
								cmd = bc.StringFromBytes(b2)
								Log ( "Comando: " , cmd )
							Case 3
								par1 = bc.StringFromBytes(b2)
								Dim parb1 () As Byte = b2
								Log ( "par1: " , par1)
							Case 4
								par2 = bc.StringFromBytes(b2)
								Dim parb2 () As Byte = b2
								Log ( "par2: " , par2)
							Case 5
								par3 = bc.StringFromBytes(b2)
								Log ( "par3: " , par3)
						End Select
						i2 = i2 + 1
					Next
					
				End If
				i1 = i1 + 1
			Next
			Log(StackBufferUsage)
			Select cmd
				Case "mac"
					Log ( "***** MAC **********")
					Log(bc.HexFromBytes(MacAddress))
					Log ( "********************")
					Astream.Write(bc.HexFromBytes(MacAddress)).Write(CRLF)
				Case "redes"  'indica as redes  par2 =string com ssid,psw;ssid,psw..... até 200 bytes
					eeprom.WriteBytes (parb1, Pos_Redes)
					eeprom.WriteBytes(Array As Byte(0), Pos_Redes + par1.Length )
Log ( "Dados Salvos " ,par1 )					
'					SaveNetworkDetails ( par1)
					Astream.Write ( "Dados Rede Salvos ").write( par1 )
'					Astream.Write ( bc.StringToBytes ( "Dados Rede Salvos ")).write( bc.StringToBytes (par1) )
				Case "teste"   'testar conexão rede wifi  par2=ssid e par2 psw
					xResp = Ck_Wifi ( par1, par2 )
					Astream.Write ( xResp )
'					Astream.Write ( bc.StringToBytes(xResp) )
				Case "telefone"  'recebe o telefone autorizado em par2
					eeprom.WriteBytes (parb1, Pos_Telefone)
					eeprom.WriteBytes(Array As Byte(0), Pos_Telefone + par1.Length )
					Astream.Write ( "Telefone Salvo ").Write ( par1 )
					'					Astream.Write ( bc.StringToBytes("Telefone Salvo ")).Write ( bc.StringToBytes (par1) )
				Case "eeprom"
'					xResp = Le_Eeprom ( Pos_Telefone, 20)
'					Log ( "Tefefonex: ", bc.StringFromBytes ( bc.HexToBytes ( xResp)) )
					Dim xResp1() As Byte  = Le_Eeprom ( Pos_Redes, 100)
					Log ( "Redesx: ", bc.StringFromBytes ( xResp1 ))
'					Astream.Write( "Telefone: ").Write ( bc.StringFromBytes ( bc.HexToBytes ( xResp ) )).Write(CRLF).Write (" / Redes: ")
					Astream.Write( bc.StringFromBytes ( xResp1))
			End Select
			server.Socket.Stream.Flush
			
'			Astream.Write("HTTP/1.1 200").Write(CRLF)
'			Astream.Write("Content-Type: text/html").Write(CRLF).Write(CRLF)
'			Astream.Write("<script>setTimeout(function(){location.href=""http://192.168.4.1""} , 20000);</script>")
'			Astream.Write("WiFi set to: ").Write(ssid).Write(", password: ").Write(password).Write("<br/>Please wait...")
'			SaveNetworkDetails(ssid, password)
'			CallSubPlus("ConnectWifi", 500, 0)
    	Else
			Astream.Write("HTTP/1.1 404").Write(CRLF)
		End If
		CallSubPlus("CloseConnection", 200, 0)
	End If
End Sub

Private Sub CloseConnection(u As Byte)
	Log("close connection")
	If server.Socket.Connected Then
		server.Socket.Stream.Flush
		server.Socket.Close
	End If
	server.Listen
End Sub

Private Sub AStream_Error
	Log("Disconnected")
	server.Listen
End Sub

Public Sub ReplaceString(Original() As Byte, SearchFor() As Byte, ReplaceWith() As Byte) As Byte()
	'count number of occurrences
	Dim bc2 As ByteConverter
	Dim c As Int = 0
	Dim i As Int
	If SearchFor.Length <> ReplaceWith.Length Then
		i = bc2.IndexOf(Original, SearchFor)
		Do While i > -1 
			c = c + 1
			i = bc2.IndexOf2(Original, SearchFor, i + SearchFor.Length)
		Loop
	End If
	Dim result(Original.Length + c * (ReplaceWith.Length - SearchFor.Length)) As Byte
	Dim prevIndex As Int = 0
	Dim targetIndex As Int = 0
	i = bc2.IndexOf(Original, SearchFor)
	Do While i > -1 
		bc2.ArrayCopy2(Original, prevIndex, result, targetIndex, i - prevIndex)
		targetIndex = targetIndex + i - prevIndex
		bc2.ArrayCopy2(ReplaceWith, 0, result, targetIndex, ReplaceWith.Length)
		targetIndex = targetIndex + ReplaceWith.Length
		prevIndex = i + SearchFor.Length
		i = bc2.IndexOf2(Original, SearchFor, prevIndex)
	Loop
	If prevIndex < Original.Length Then
		bc2.ArrayCopy2(Original, prevIndex, result, targetIndex, Original.Length - prevIndex)
	End If
	Return result
End Sub

'  Log(bc.HexFromBytes(MacAddress))
Sub MacAddress() As Byte()
	RunNative("getMac", Null)
	Return macarray
End Sub
#if C
  #include <ESP8266WiFi.h>
  void getMac(B4R::Object* u) {
  WiFi.macAddress((Byte*)b4r_wifiserver::_macarray->data);
  }
#end if


Sub Ck_Wifi ( pSSId As String, pPsw As String ) As String
	Dim xIP As String
	Log("Trying to connect to: ", pSSId, " password: ", pPsw)
	If Main.Wifi.Connect2(pSSId, pPsw) Then
		Log("Connected successfully to: ", pSSId)
		Log(Main.Wifi.LocalIp)
		xIP = Main.Wifi.LocalIp
		Main.Wifi.Disconnect
		Return xIP
	Else
		Log("Failed to connect.")
		xIP = "Er: conexao"
		Main.Wifi.Disconnect
		Return xIP
	End If
End Sub

Sub Le_Eeprom ( pStart As UInt, pMax As UInt ) As Byte()
	Dim i, xCnt, ate As UInt
	Dim xTemp As String
	i = pStart
	xCnt = 0
	ate = i + pMax
	Do While i < ate
		xTemp =  bc.HexFromBytes (eeprom.ReadBytes ( i,1) )
Log ( xTemp)
		If xTemp <> "00" Then
			xCnt = xCnt + 1
		Else
			i = ate + 1	
		End If
		i = i + 1
	Loop
	Dim xResp() As Byte = eeprom.ReadBytes(pStart,xCnt+1) 
	Log ( xCnt )
	Return xResp
End Sub